//
//  Board.swift
//  
//
//  Created by Adam BONAFOS on 13/01/2025.
//

import Foundation

public struct Board {
    public let rowNb: Int
    public let columnNb: Int
    var grid: [[Token]]
    
    public init(rowsNb: Int = 6, columnsNb: Int = 7) {
        rowNb = rowsNb
        columnNb = columnsNb
        grid = Array(repeating: Array(repeating: Token.empty, count: columnsNb), count: rowsNb)
    }
    
    public subscript(row: Int, column: Int) -> Token {
        get {
            guard row >= 0 && row < rowNb && column >= 0 && column < columnNb else {
                fatalError("Out of board")
            }
            return grid[row][column]
        }
        set {
            guard row >= 0 && row < rowNb && column >= 0 && column < columnNb else {
                fatalError("Out of board")
            }
            grid[row][column] = newValue
        }
    }
}
